﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Dynamicweb.eCommerce.Products;
using Dynamicweb.Frontend;
using Dynamicweb.Samples.Lib.Model;

namespace Dynamicweb.Samples.Lib
{
	public class ExtendAddToFavoritesTemplate : ProductTemplateExtender
	{
		public override void ExtendTemplate(Dynamicweb.Templatev2.Template Template)
		{
			int userId = new Extranet().UserID;
			string favoritesCacheKey = String.Format(
								Constants.CacheKeys.UserFavorites, userId);

			List<EcomCustomerFavoriteProduct> userFavorites =
											HttpContext.Current.Cache[favoritesCacheKey]
											as List<EcomCustomerFavoriteProduct>;
			if (userFavorites == null)
			{
				using (SamplesEntities db = new SamplesEntities())
				{
					userFavorites = (from p in db.EcomCustomerFavoriteProducts
													 where p.EcomCustomerFavoriteList.AccessUserID == userId
													 select p).ToList();
					HttpContext.Current.Cache[favoritesCacheKey] = userFavorites;
				}
			}

			var hasproduct = (from p in userFavorites
												where p.ProductID == Product.ID &&
												p.ProductVariantID == Product.VariantID &&
												p.ProductLanguageID == Product.LanguageID
												select p).Count() > 0;

			if (hasproduct)
			{
				Template.SetTag("Ecom:Product.AddToFavorites", string.Empty);
			}
			else
			{
				Template.SetTag("Ecom:Product.RemoveFromFavorites", string.Empty);
			}
		}
	}    
}