﻿using System;
using System.Web;
using Dynamicweb;
using Dynamicweb.Extensibility;
using Dynamicweb.Frontend;
using Dynamicweb.Notifications;

namespace Dynamicweb.Samples.Lib
{
	[Subscribe(Standard.Page.Loaded)]
	public class OnFavoritesChanged : NotificationSubscriber
	{
		public override void OnNotify(string notification, object[] args)
		{
			string addFavorite = Base.Request("CCAddToFavorites");
			string removeFavorite = Base.Request("CCRemoveFromFavorites");

			if (string.IsNullOrEmpty(addFavorite) && string.IsNullOrEmpty(removeFavorite))
			{
				return;
			}
			else
			{
				int userId = new Extranet().UserID;
				// User added or removed a favorite; clear the entire cache. 
				// Alternatively, you could just update the selected product in the cached list.
				HttpContext.Current.Cache.Remove(String.Format(Constants.CacheKeys.UserFavorites, userId));
			}
		}
	}
}

